diff --git a/reviewboard/hostingsvcs/assembla.py b/reviewboard/hostingsvcs/assembla.py
index 41aaf68102af7eb36957fcc9f090d523b7054a54..06864e154d8b2f360820abb74ccb716cf92bf49d 100644
--- a/reviewboard/hostingsvcs/assembla.py
+++ b/reviewboard/hostingsvcs/assembla.py
@@ -1,12 +1,23 @@
+"""Hosting service for Assembla."""
+
+from __future__ import annotations
+
+from typing import TYPE_CHECKING
+
 from django import forms
 from django.utils.translation import gettext_lazy as _
+from housekeeping import deprecate_non_keyword_only_args
 
 from reviewboard.admin.server import get_hostname
+from reviewboard.deprecation import RemovedInReviewBoard90Warning
 from reviewboard.hostingsvcs.base.forms import BaseHostingServiceRepositoryForm
 from reviewboard.hostingsvcs.base.hosting_service import BaseHostingService
 from reviewboard.scmtools.crypto_utils import (decrypt_password,
                                                encrypt_password)
 
+if TYPE_CHECKING:
+    from reviewboard.scmtools.core import SCMTool
+
 
 class AssemblaForm(BaseHostingServiceRepositoryForm):
     assembla_project_id = forms.CharField(
@@ -95,45 +106,62 @@
         """
         return '%s-%s' % (get_hostname(), project_id.replace('/', '-'))
 
-    def check_repository(self, path, username, password, scmtool_class,
-                         local_site_name, assembla_project_id=None,
-                         *args, **kwargs):
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def check_repository(
+        self,
+        *,
+        path: str | None,
+        username: str | None,
+        password: str | None,
+        scmtool_class: type[SCMTool],
+        local_site_name: str | None,
+        assembla_project_id: str,
+        **kwargs,
+    ) -> None:
         """Check the validity of a repository hosted on Assembla.
 
         Perforce repositories are handled specially. The Assembla project ID
         will be used as the Perforce host, which is needed to tell Assembla
         which repository on the server to use.
 
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
         Args:
-            path (unicode):
+            path (str):
                 The repository path.
 
-            username (unicode):
+            username (str):
                 The username used for authenticating.
 
-            password (unicode):
+            password (str):
                 The password used for authenticating.
 
             scmtool_class (type):
                 The SCMTool for the repository.
 
-            local_site_name (unicode):
+            local_site_name (str):
                 The name of the Local Site, if any.
 
-            assembla_project_id (unicode):
+            assembla_project_id (str):
                 The project ID for the Assembla team.
 
-            *args (tuple):
-                Additional arguments to pass to the superclass.
-
             **kwargs (dict):
-                Additional keyword arguments to pass to the superclass.
+                Additional keyword arguments passed by the repository form.
+
+        Raises:
+            ValueError:
+                The value of a field was incorrect.
         """
         # We want to use the configured username and other information from
         # the account.
         username = self.account.username
         password = self.get_password()
 
+        if path is None:
+            raise ValueError('path cannot be None')
+
         if scmtool_class.name == 'Perforce':
             scmtool_class.check_repository(
                 path=path,
@@ -143,7 +171,7 @@
                 p4_host=assembla_project_id,
                 p4_client=self.make_p4_client_name(assembla_project_id))
         else:
-            super(Assembla, self).check_repository(
+            super().check_repository(
                 path=path,
                 username=username,
                 password=password,
@@ -151,24 +179,32 @@
                 scmtool_class=scmtool_class,
                 **kwargs)
 
-    def authorize(self, username, password, *args, **kwargs):
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
+    def authorize(
+        self,
+        *,
+        username: str | None,
+        password: str | None,
+        **kwargs,
+    ) -> None:
         """Authorize the Assembla account.
 
         For Assembla, we simply use the native SCMTool support, as there's
         no useful API available. We just store the password encrypted, which
         will be used by the SCMTool.
 
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
         Args:
-            username (unicode):
+            username (str):
                 The username for authentication.
 
-            password (unicode):
+            password (str):
                 The password for authentication.
 
-            *args (tuple):
-                Additional arguments.
-
-            **kwargs (dict):
+            **kwargs (dict, unused):
                 Additional keyword arguments.
         """
         self.account.data['password'] = encrypt_password(password)
diff --git a/reviewboard/hostingsvcs/base/client.py b/reviewboard/hostingsvcs/base/client.py
index 5297a317277830dd248ee2d16f671f673b3a0f46..d688ccb6fc5380fb534851d37dabe2a8eb5d0ffe 100644
--- a/reviewboard/hostingsvcs/base/client.py
+++ b/reviewboard/hostingsvcs/base/client.py
@@ -13,7 +13,7 @@
 import logging
 import ssl
 from email.generator import _make_boundary as generate_boundary
-from typing import Callable, Optional, TYPE_CHECKING, Tuple, Type, Union
+from typing import TYPE_CHECKING
 from urllib.error import URLError
 from urllib.parse import urlparse
 
@@ -30,6 +30,8 @@
 from reviewboard.scmtools.errors import UnverifiedCertificateError
 
 if TYPE_CHECKING:
+    from typing import Callable
+
     from typelets.json import JSONValue
 
     from reviewboard.hostingsvcs.base.hosting_service import (
@@ -70,7 +72,7 @@
     #:
     #: Version Added:
     #:     4.0
-    http_request_cls: Type[HostingServiceHTTPRequest] = \
+    http_request_cls: type[HostingServiceHTTPRequest] = \
         HostingServiceHTTPRequest
 
     #: The HTTP response class to construct HTTP responses.
@@ -80,7 +82,7 @@
     #:
     #: Version Added:
     #:     4.0
-    http_response_cls: Type[HostingServiceHTTPResponse] = \
+    http_response_cls: type[HostingServiceHTTPResponse] = \
         HostingServiceHTTPResponse
 
     #: Whether to add HTTP Basic Auth headers by default.
@@ -131,7 +133,7 @@
     def http_delete(
         self,
         url: str,
-        headers: Optional[HTTPHeaders] = None,
+        headers: (HTTPHeaders | None) = None,
         *args,
         **kwargs,
     ) -> HostingServiceHTTPResponse:
@@ -178,7 +180,7 @@
     def http_get(
         self,
         url: str,
-        headers: Optional[HTTPHeaders] = None,
+        headers: (HTTPHeaders | None) = None,
         *args,
         **kwargs,
     ) -> HostingServiceHTTPResponse:
@@ -225,7 +227,7 @@
     def http_head(
         self,
         url: str,
-        headers: Optional[HTTPHeaders] = None,
+        headers: (HTTPHeaders | None) = None,
         *args,
         **kwargs,
     ) -> HostingServiceHTTPResponse:
@@ -270,11 +272,11 @@
     def http_post(
         self,
         url: str,
-        body: Optional[bytes] = None,
-        fields: Optional[FormFields] = None,
-        files: Optional[UploadedFiles] = None,
-        content_type: Optional[str] = None,
-        headers: Optional[HTTPHeaders] = None,
+        body: (bytes | None) = None,
+        fields: (FormFields | None) = None,
+        files: (UploadedFiles | None) = None,
+        content_type: (str | None) = None,
+        headers: (HTTPHeaders | None) = None,
         *args,
         **kwargs,
     ) -> HostingServiceHTTPResponse:
@@ -351,11 +353,11 @@
     def http_put(
         self,
         url: str,
-        body: Optional[bytes] = None,
-        fields: Optional[FormFields] = None,
-        files: Optional[UploadedFiles] = None,
-        content_type: Optional[str] = None,
-        headers: Optional[HTTPHeaders] = None,
+        body: (bytes | None) = None,
+        fields: (FormFields | None) = None,
+        files: (UploadedFiles | None) = None,
+        content_type: (str | None) = None,
+        headers: (HTTPHeaders | None) = None,
         *args,
         **kwargs,
     ) -> HostingServiceHTTPResponse:
@@ -429,8 +431,8 @@
     def http_request(
         self,
         url: str,
-        body: Optional[bytes] = None,
-        headers: Optional[HTTPHeaders] = None,
+        body: (bytes | None) = None,
+        headers: (HTTPHeaders | None) = None,
         method: str = 'GET',
         **kwargs,
     ) -> HostingServiceHTTPResponse:
@@ -523,8 +525,8 @@
     def get_http_credentials(
         self,
         account: HostingServiceAccount,
-        username: Optional[str] = None,
-        password: Optional[str] = None,
+        username: (str | None) = None,
+        password: (str | None) = None,
         **kwargs,
     ) -> HostingServiceCredentials:
         """Return credentials used to authenticate with the service.
@@ -762,7 +764,7 @@
         self,
         *args,
         **kwargs,
-    ) -> Tuple[JSONValue, HTTPHeaders]:
+    ) -> tuple[JSONValue, HTTPHeaders]:
         """Perform an HTTP DELETE and interpret the results as JSON.
 
         Deprecated:
@@ -814,7 +816,7 @@
         self,
         *args,
         **kwargs,
-    ) -> Tuple[JSONValue, HTTPHeaders]:
+    ) -> tuple[JSONValue, HTTPHeaders]:
         """Perform an HTTP GET and interpret the results as JSON.
 
         Deprecated:
@@ -866,7 +868,7 @@
         self,
         *args,
         **kwargs,
-    ) -> Tuple[JSONValue, HTTPHeaders]:
+    ) -> tuple[JSONValue, HTTPHeaders]:
         """Perform an HTTP POST and interpret the results as JSON.
 
         Deprecated:
@@ -916,11 +918,13 @@
 
     def _do_json_method(
         self,
-        method: Callable[..., Union[Tuple[bytes, HTTPHeaders],
-                                    HostingServiceHTTPResponse]],
+        method: Callable[
+            ...,
+            tuple[bytes, HTTPHeaders] | HostingServiceHTTPResponse
+        ],
         *args,
         **kwargs,
-    ) -> Tuple[JSONValue, HTTPHeaders]:
+    ) -> tuple[JSONValue, HTTPHeaders]:
         """Parse the result of an HTTP operation as JSON.
 
         Deprecated:
@@ -971,16 +975,16 @@
 
             return data, headers
         else:
-            raise NotImplementedError('Unsupported response from %r' % method)
+            raise NotImplementedError(f'Unsupported response from {method!r}')
 
     def _build_put_post_request(
         self,
-        body: Optional[bytes] = None,
-        fields: Optional[FormFields] = None,
-        files: Optional[UploadedFiles] = None,
-        content_type: Optional[str] = None,
-        headers: Optional[HTTPHeaders] = None,
-    ) -> Tuple[bytes, HTTPHeaders]:
+        body: (bytes | None) = None,
+        fields: (FormFields | None) = None,
+        files: (UploadedFiles | None) = None,
+        content_type: (str | None) = None,
+        headers: (HTTPHeaders | None) = None,
+    ) -> tuple[bytes, HTTPHeaders]:
         """Build a request body and headers for a HTTP PUT or POST.
 
         Args:
@@ -1030,7 +1034,7 @@
         if content_type:
             headers['Content-Type'] = content_type
 
-        headers['Content-Length'] = '%d' % len(body)
+        headers['Content-Length'] = str(len(body))
 
         return body, headers
 
@@ -1040,9 +1044,9 @@
 
     @staticmethod
     def build_form_data(
-        fields: Optional[FormFields],
-        files: Optional[UploadedFiles] = None,
-    ) -> Tuple[bytes, str]:
+        fields: FormFields | None,
+        files: (UploadedFiles | None) = None,
+    ) -> tuple[bytes, str]:
         """Encode data for use in an HTTP POST.
 
         Args:
@@ -1119,7 +1123,7 @@
         content_parts.append(b'--%s--' % enc_boundary)
 
         content = b''.join(content_parts)
-        content_type = 'multipart/form-data; boundary=%s' % boundary
+        content_type = f'multipart/form-data; boundary={boundary}'
 
         return content, content_type
 
diff --git a/reviewboard/hostingsvcs/base/forms.py b/reviewboard/hostingsvcs/base/forms.py
index 02d08176b8629ea9dbf200f326a4555f970b1372..5647ea20c116d5161cc521d36305a19c1e3ee97f 100644
--- a/reviewboard/hostingsvcs/base/forms.py
+++ b/reviewboard/hostingsvcs/base/forms.py
@@ -8,10 +8,11 @@
 from __future__ import annotations
 
 import logging
-from typing import Optional, TYPE_CHECKING, Type
+from typing import TYPE_CHECKING
 
 from django import forms
 from django.utils.translation import gettext, gettext_lazy as _
+from typelets.runtime import raise_invalid_type
 
 from reviewboard.hostingsvcs.errors import (AuthorizationError,
                                             TwoFactorAuthCodeRequiredError)
@@ -57,12 +58,12 @@
     #:
     #: Type:
     #:     type
-    hosting_service_cls: Type[BaseHostingService]
+    hosting_service_cls: type[BaseHostingService]
 
     def __init__(
         self,
         *args,
-        hosting_service_cls: Type[BaseHostingService],
+        hosting_service_cls: type[BaseHostingService],
         **kwargs,
     ) -> None:
         """Initialize the authentication form.
@@ -84,7 +85,8 @@
                 message.
         """
         if not hosting_service_cls:
-            raise ValueError('hosting_service_cls cannot be None.')
+            raise_invalid_type(hosting_service_cls,
+                               'hosting_service_cls cannot be None.')
 
         self.hosting_service_cls = hosting_service_cls
 
@@ -188,12 +190,12 @@
     #:
     #: Type:
     #:     reviewboard.hostingsvcs.models.HostingServiceAccount
-    hosting_account: Optional[HostingServiceAccount]
+    hosting_account: HostingServiceAccount | None
 
     def __init__(
         self,
         *args,
-        hosting_account: Optional[HostingServiceAccount] = None,
+        hosting_account: (HostingServiceAccount | None) = None,
         **kwargs,
     ) -> None:
         """Initialize the authentication form.
@@ -314,7 +316,7 @@
         self,
         allow_authorize: bool = True,
         force_authorize: bool = False,
-        extra_authorize_kwargs: Optional[KwargsDict] = None,
+        extra_authorize_kwargs: (KwargsDict | None) = None,
         trust_host: bool = False,
         save: bool = True,
     ) -> HostingServiceAccount:
@@ -387,7 +389,7 @@
 
         hosting_account = self.hosting_account
         hosting_service_id = self.hosting_service_cls.hosting_service_id
-        hosting_url: Optional[str] = self.cleaned_data.get('hosting_url')
+        hosting_url: (str | None) = self.cleaned_data.get('hosting_url')
 
         assert hosting_service_id
 
@@ -423,7 +425,7 @@
             self.hosting_service_cls.needs_authorization and
             (not hosting_account.is_authorized or force_authorize)):
             # Attempt to authorize the account.
-            local_site_name: Optional[str] = None
+            local_site_name: (str | None) = None
 
             if self.local_site:
                 local_site_name = self.local_site.name
@@ -460,8 +462,8 @@
         self,
         hosting_account: HostingServiceAccount,
         hosting_service_id: str,
-        username: Optional[str] = None,
-        local_site_name: Optional[str] = None,
+        username: (str | None) = None,
+        local_site_name: (str | None) = None,
         **kwargs,
     ) -> None:
         """Authorize the service.
@@ -518,7 +520,7 @@
             # Re-raise the error.
             raise
 
-    def clean_hosting_url(self) -> Optional[str]:
+    def clean_hosting_url(self) -> str | None:
         """Clean the hosting URL field.
 
         Returns:
@@ -611,7 +613,7 @@
 
     def load(
         self,
-        repository: Optional[Repository] = None,
+        repository: (Repository | None) = None,
         **kwargs,
     ) -> None:
         """Load information for the form.
@@ -626,12 +628,15 @@
 
                 This is scheduled to be deprecated. Subclasses should use the
                 :py:attr:`repository` attribute instead.
+
+            **kwargs (dict, unused):
+                Unused keyword arguments.
         """
         super().load()
 
     def save(
         self,
-        repository: Optional[Repository] = None,
+        repository: (Repository | None) = None,
         **kwargs,
     ) -> None:
         """Save information from the form back to the repository.
@@ -645,6 +650,9 @@
 
                 This is scheduled to be deprecated. Subclasses should use the
                 :py:attr:`repository` attribute instead.
+
+            **kwargs (dict, unused):
+                Unused keyword arguments.
         """
         if repository is None:
             repository = self.repository
diff --git a/reviewboard/hostingsvcs/base/hosting_service.py b/reviewboard/hostingsvcs/base/hosting_service.py
index c1c27223e118415c18932a23f9c9c9512ae3a5a1..f201dec35dd33545a6ebf0e91deec44badaad87e 100644
--- a/reviewboard/hostingsvcs/base/hosting_service.py
+++ b/reviewboard/hostingsvcs/base/hosting_service.py
@@ -9,26 +9,34 @@
 from __future__ import annotations
 
 import logging
-from typing import (Any, Dict, List, Mapping, Optional, Sequence,
-                    TYPE_CHECKING, Tuple, Type)
+from collections.abc import Mapping
+from typing import Any, Dict, TYPE_CHECKING
 from urllib.parse import urlparse
 
 from django.utils.translation import gettext_lazy as _
-from typing_extensions import NotRequired, TypeAlias, TypedDict
+from housekeeping import deprecate_non_keyword_only_args
+from typing_extensions import TypedDict
 
+from reviewboard.deprecation import RemovedInReviewBoard90Warning
 from reviewboard.hostingsvcs.base.client import HostingServiceClient
 
 if TYPE_CHECKING:
+    from collections.abc import Sequence
+    from typing import ClassVar
+
+    from typing_extensions import TypeAlias
+
     from django.http import HttpRequest
     from django.urls import _AnyURL
     from django.utils.safestring import SafeString
     from paramiko import PKey
     from typelets.django.strings import StrOrPromise
+    from typing_extensions import NotRequired
 
     from reviewboard.hostingsvcs.base.forms import (
         BaseHostingServiceAuthForm,
         BaseHostingServiceRepositoryForm)
-    from reviewboard.hostingsvcs.base.paginator import APIPaginator
+    from reviewboard.hostingsvcs.base.paginator import BasePaginator
     from reviewboard.hostingsvcs.models import HostingServiceAccount
     from reviewboard.hostingsvcs.repository import RemoteRepository
     from reviewboard.scmtools.core import Branch, Commit, SCMTool
@@ -70,7 +78,7 @@
     #:
     #: Type:
     #:     type
-    form: NotRequired[Type[BaseHostingServiceRepositoryForm]]
+    form: NotRequired[type[BaseHostingServiceRepositoryForm]]
 
     #: Templated values to set for model repository fields.
     #:
@@ -142,13 +150,13 @@
     #:
     #: Type:
     #:     str
-    hosting_service_id: Optional[str] = None
+    hosting_service_id: ClassVar[str | None] = None
 
     #: The display name for the hosting service.
     #:
     #: Type:
     #:     str
-    name: Optional[StrOrPromise] = None
+    name: ClassVar[StrOrPromise | None] = None
 
     #: A list of available hosting service plans.
     #:
@@ -159,7 +167,7 @@
     #:
     #: Type:
     #:     list
-    plans: Optional[Sequence[Tuple[str, HostingServicePlan]]] = None
+    plans: ClassVar[Sequence[tuple[str, HostingServicePlan]] | None] = None
 
     #: Whether this service supports bug trackers.
     #:
@@ -171,7 +179,7 @@
     #:
     #: Type:
     #:     bool
-    supports_bug_trackers: bool = False
+    supports_bug_trackers: ClassVar[bool] = False
 
     #: Whether this service supports post-commit requests.
     #:
@@ -184,7 +192,7 @@
     #:
     #: Type:
     #:     bool
-    supports_post_commit: bool = False
+    supports_post_commit: ClassVar[bool] = False
 
     #: Whether this service supports source code repositories.
     #:
@@ -201,7 +209,7 @@
     #:
     #: Type:
     #:     bool
-    supports_repositories: bool = False
+    supports_repositories: ClassVar[bool] = False
 
     #: Whether this service supports automatic association of SSH keys.
     #:
@@ -214,7 +222,7 @@
     #:
     #: Type:
     #:     bool
-    supports_ssh_key_association: bool = False
+    supports_ssh_key_association: ClassVar[bool] = False
 
     #: Whether this service supports two-factor authentication.
     #:
@@ -224,7 +232,7 @@
     #:
     #: Type:
     #:     bool
-    supports_two_factor_auth: bool = False
+    supports_two_factor_auth: ClassVar[bool] = False
 
     #: Whether this service supports listing remote repositories.
     #:
@@ -237,7 +245,7 @@
     #:
     #: Type:
     #:     bool
-    supports_list_remote_repositories: bool = False
+    supports_list_remote_repositories: ClassVar[bool] = False
 
     #: Whether this service provides repository hook instructions.
     #:
@@ -248,7 +256,7 @@
     #:
     #: Type:
     #:     bool
-    has_repository_hook_instructions: bool = False
+    has_repository_hook_instructions: ClassVar[bool] = False
 
     #: Whether this service should be shown as an available option.
     #:
@@ -262,7 +270,7 @@
     #:
     #: Type:
     #:     bool
-    visible: bool = True
+    visible: ClassVar[bool] = True
 
     #: Whether this service can be self-hosted.
     #:
@@ -271,7 +279,7 @@
     #:
     #: Type:
     #:     bool
-    self_hosted: bool = False
+    self_hosted: ClassVar[bool] = False
 
     #: Custom URL patterns to include for the hosting service.
     #:
@@ -283,7 +291,7 @@
     #:
     #: Type:
     #:     list
-    repository_url_patterns: Optional[List[_AnyURL]] = None
+    repository_url_patterns: ClassVar[list[_AnyURL] | None] = None
 
     #: The utility class used to perform client functionality.
     #:
@@ -296,7 +304,7 @@
     #:
     #: Type:
     #:     type
-    client_class: Type[HostingServiceClient] = HostingServiceClient
+    client_class: ClassVar[type[HostingServiceClient]] = HostingServiceClient
 
     #: Optional form used to configure authentication settings for an account.
     #:
@@ -304,7 +312,7 @@
     #:
     #: Type:
     #:     type
-    auth_form: Optional[Type[BaseHostingServiceAuthForm]] = None
+    auth_form: ClassVar[type[BaseHostingServiceAuthForm] | None] = None
 
     #: Whether usage of this hosting service requires authorization.
     #:
@@ -312,7 +320,7 @@
     #:
     #: Type:
     #:     bool
-    needs_authorization: bool = False
+    needs_authorization: ClassVar[bool] = False
 
     #: Optional form used to configure repository settings.
     #:
@@ -322,7 +330,7 @@
     #:
     #: Type:
     #:     type
-    form: Optional[Type[BaseHostingServiceRepositoryForm]] = None
+    form: ClassVar[type[BaseHostingServiceRepositoryForm] | None] = None
 
     #: Templated values to set for model repository fields.
     #:
@@ -333,7 +341,7 @@
     #:
     #: Type:
     #:     dict
-    repository_fields: SCMToRepositoryFields = {}
+    repository_fields: ClassVar[SCMToRepositoryFields] = {}
 
     #: A templated value for the bug tracker field.
     #:
@@ -342,7 +350,7 @@
     #:
     #: Type:
     #:     str
-    bug_tracker_field: Optional[str] = None
+    bug_tracker_field: ClassVar[str | None] = None
 
     #: A list of SCMTools IDs or names that are supported by this service.
     #:
@@ -359,7 +367,7 @@
     #:
     #: Type:
     #:     list of str
-    supported_scmtools: List[str] = []
+    supported_scmtools: ClassVar[Sequence[str]] = []
 
     #: A list of SCMTool IDs that are visible when configuring the service.
     #:
@@ -379,7 +387,7 @@
     #:
     #: Type:
     #:     list of str
-    visible_scmtools: Optional[List[str]] = None
+    visible_scmtools: ClassVar[Sequence[str] | None] = None
 
     ######################
     # Instance variables #
@@ -420,7 +428,7 @@
         """
         return False
 
-    def get_password(self) -> Optional[str]:
+    def get_password(self) -> str | None:
         """Return the raw password for this hosting service.
 
         Not all hosting services provide this, and not all would need it.
@@ -487,19 +495,24 @@
         """
         raise NotImplementedError
 
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
     def authorize(
         self,
-        username: Optional[str],
-        password: Optional[str],
-        hosting_url: Optional[str],
-        credentials: HostingServiceCredentials,
-        two_factor_auth_code: Optional[str] = None,
-        local_site_name: Optional[str] = None,
-        *args,
+        *,
+        username: str | None,
+        password: str | None,
+        hosting_url: (str | None) = None,
+        credentials: (HostingServiceCredentials | None) = None,
+        two_factor_auth_code: (str | None) = None,
+        local_site_name: (str | None) = None,
         **kwargs,
     ) -> None:
         """Authorize an account for the hosting service.
 
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
         Args:
             username (str):
                 The username for the account.
@@ -507,10 +520,10 @@
             password (str):
                 The password for the account.
 
-            hosting_url (str):
+            hosting_url (str, optional):
                 The hosting URL for the service, if self-hosted.
 
-            credentials (dict):
+            credentials (dict, optional):
                 All credentials provided by the authentication form.
 
                 This will contain the username, password, and anything else
@@ -523,9 +536,6 @@
                 The Local Site name, if any, that the account should be
                 bound to.
 
-            *args (tuple):
-                Extra unused positional arguments.
-
             **kwargs (dict):
                 Extra keyword arguments containing values from the
                 repository's configuration.
@@ -542,17 +552,18 @@
         """
         raise NotImplementedError
 
+    @deprecate_non_keyword_only_args(RemovedInReviewBoard90Warning)
     def check_repository(
         self,
-        path: str,
-        username: Optional[str],
-        password: Optional[str],
-        scmtool_class: Type[SCMTool],
-        local_site_name: Optional[str],
-        *args,
+        *,
+        path: str | None,
+        username: str | None,
+        password: str | None,
+        scmtool_class: type[SCMTool],
+        local_site_name: str | None,
         **kwargs,
     ) -> None:
-        """Checks the validity of a repository configuration.
+        """Check the validity of a repository configuration.
 
         This performs a check against the hosting service or repository
         to ensure that the information provided by the user represents
@@ -563,6 +574,10 @@
         LocalSite's name (if any), and all field data from the
         HostingServiceForm as keyword arguments.
 
+        Version Changed:
+            7.1:
+            Made arguments keyword-only.
+
         Args:
             path (str):
                 The repository URL.
@@ -577,14 +592,10 @@
                 The subclass of :py:class:`~reviewboard.scmtools.core.SCMTool`
                 that should be used.
 
-            local_site_name (unicode):
+            local_site_name (str):
                 The name of the local site associated with the repository, or
                 ``None``.
 
-            *args (tuple):
-                Additional positional arguments, unique to each hosting
-                service.
-
             **kwargs (dict):
                 Additional keyword arguments, unique to each hosting service.
 
@@ -592,6 +603,7 @@
             reviewboard.hostingsvcs.errors.RepositoryError:
                 The repository is not valid.
         """
+        assert path is not None
         scmtool_class.check_repository(path, username, password,
                                        local_site_name)
 
@@ -704,8 +716,8 @@
     def get_commits(
         self,
         repository: Repository,
-        branch: Optional[str] = None,
-        start: Optional[str] = None,
+        branch: (str | None) = None,
+        start: (str | None) = None,
     ) -> Sequence[Commit]:
         """Return a list of commits backward in history from a given point.
 
@@ -770,13 +782,13 @@
 
     def get_remote_repositories(
         self,
-        owner: Optional[str] = None,
-        owner_type: Optional[str] = None,
-        filter_type: Optional[str] = None,
-        start: Optional[int] = None,
-        per_page: Optional[int] = None,
+        owner: (str | None) = None,
+        owner_type: (str | None) = None,
+        filter_type: (str | None) = None,
+        start: (int | None) = None,
+        per_page: (int | None) = None,
         **kwargs,
-    ) -> APIPaginator:
+    ) -> BasePaginator[RemoteRepository, Any]:
         """Return a list of remote repositories for the owner.
 
         This method should be implemented by subclasses.
@@ -800,8 +812,11 @@
             per_page (int, optional):
                 The number of results per page.
 
+            **kwargs (dict):
+                Additional keyword arguments.
+
         Returns:
-            reviewboard.hostingsvcs.utils.APIPaginator:
+            reviewboard.hostingsvcs.utils.BasePaginator:
             A paginator for the returned repositories.
         """
         raise NotImplementedError
@@ -871,10 +886,10 @@
     def get_repository_fields(
         cls,
         username: str,
-        hosting_url: Optional[str],
-        plan: str,
+        hosting_url: str | None,
+        plan: str | None,
         tool_name: str,
-        field_vars: Dict[str, str],
+        field_vars: dict[str, str],
     ) -> RepositoryFields:
         """Return the repository fields based on the given plan and tool.
 
@@ -972,7 +987,7 @@
     @classmethod
     def get_bug_tracker_requires_username(
         cls,
-        plan: Optional[str] = None,
+        plan: (str | None) = None,
     ) -> bool:
         """Return whether or not the bug tracker requires usernames.
 
@@ -1000,8 +1015,8 @@
     @classmethod
     def get_bug_tracker_field(
         cls,
-        plan: str,
-        field_vars: Dict[str, str],
+        plan: str | None,
+        field_vars: dict[str, str],
     ) -> str:
         """Return the bug tracker field for the given plan.
 
@@ -1016,7 +1031,7 @@
             str:
             The value of the bug tracker field.
 
-        Raises
+        Raises:
             KeyError:
                The provided plan is not valid for the hosting service.
         """
@@ -1044,9 +1059,9 @@
     @classmethod
     def get_field(
         cls,
-        plan: str,
+        plan: str | None,
         name: str,
-        default: Optional[str] = None,
+        default: (str | None) = None,
     ) -> Any:
         """Return the value of the field for the given plan.
 
@@ -1073,10 +1088,6 @@
 
             for plan_name, info in cls.plans:
                 if plan_name == plan and name in info:
-                    # NOTE: The type checker can complain here due to a
-                    #       non-Literal name being used to index into a
-                    #       TypedDict. However, we've already checked for
-                    #       presence above.
-                    return info[name]  # type: ignore
+                    return info[name]
 
         return getattr(cls, name, default)
